unit damier3D1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes,
  System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Objects3D, FMX.Types3D,
  FMX.Layers3D, FMX.Layouts, FMX.ListBox, System.Math, FMX.Materials,
  FMX.Gestures, System.Math.Vectors, FMX.Controls3D, FMX.Viewport3D,
  FMX.MaterialSources, FMX.StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ListBox1: TListBox;
    ArcDial1: TArcDial;
    ArcDial2: TArcDial;
    ArcDial3: TArcDial;
    Button1: TButton;
    TMS1: TTextureMaterialSource;
    TMS2: TTextureMaterialSource;
    TMS3: TTextureMaterialSource;
    terre: TTextureMaterialSource;
    Viewport3D1: TViewport3D;
    Layer3D1: TLayer3D;
    Sphere1: TSphere;
    Light1: TLight;
    procedure ArcDial1Change(Sender: TObject);
    procedure Plane1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  Bprem : boolean = true ;

implementation

{$R *.fmx}

procedure TForm1.ArcDial1Change(Sender: TObject);
begin
  Layer3D1.RotationAngle.Z := ArcDial3.value ;
  Layer3D1.RotationAngle.Y := ArcDial2.value ;
  Layer3D1.RotationAngle.X := ArcDial1.value ;
end;

procedure TForm1.Button1Click(Sender: TObject);
const
  cl1 = $FFC0C0E0 ;
  cl2 = $FF0C0C0C ;
  cl3 = $FFD0C040 ;
var
  i1 : integer ;
  P1 : TPlane ;
begin
  for i1 := 0 to ListBox1.Items.Count-1 do
  begin
    p1 := Pointer(ListBox1.Items.Objects[i1])   ;
    if p1.MaterialSource = TMS1 then
      p1.MaterialSource := TMS2
    else
      if p1.MaterialSource = TMS2 then
        p1.MaterialSource := TMS3
      else
        p1.MaterialSource := TMS1 ;
    p1.Repaint ;
  end;
end;

procedure TForm1.FormActivate(Sender: TObject);
var
  i1, i2, i3 : integer ;
  P1 : TPlane ;
  b1 : boolean ;

begin
  if not Bprem then exit ;
  Bprem := false ;
  ArcDial1.value := Layer3D1.RotationAngle.X ;
  ArcDial2.value := Layer3D1.RotationAngle.Y ;
  ArcDial3.value := Layer3D1.RotationAngle.Z ;
  Viewport3D1.repaint ;

  b1 := true ;
  for i1 := 0 to 7 do
  begin
    for i2 := 0 to 7 do
    begin
      P1 := TPlane.Create(Layer3D1) ;
      ListBox1.Items.Add('case '+intToStr(i1+1)+'x'+intToStr(i2+1)) ;
      i3 := ListBox1.Items.Count-1 ;
      ListBox1.Items.Objects[i3] := Pointer(P1) ;
      P1.Position.X := i1+0.5;
      P1.Position.Y := i2+0.5 ;
      P1.Position.Z := -0.01 ;
      P1.Width := 1 ;
      P1.Height := 1 ;
      P1.OnClick := Plane1Click ;
      if b1 then
        p1.MaterialSource := TMS1
      else
        p1.MaterialSource := TMS2 ;
      P1.Parent := Layer3D1 ;
      b1 := not b1 ;
    end;
    b1 := not b1 ;
  end;
  Viewport3D1.repaint ;
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
var
  P1 : TPlane ;
begin
  p1 := Pointer(ListBox1.Items.Objects[ListBox1.ItemIndex])   ;
  P1.Position.Z := P1.Position.Z -0.3 ;
end;

procedure TForm1.Plane1Click(Sender: TObject);
begin
  sphere1.Parent := sender as TPlane ;
end;

end.
